
sjlog using logs/ch12.1, replace
type myregress.ado
sjlog close, replace

sjlog using logs/ch12.1a, replace
use wpi1, clear
myregress wpi L(1/4).wpi t, lagvar(wpi) nlags(4)
return list
lincom   L.wpi+L2.wpi+L3.wpi+L4.wpi
sjlog close, replace

sjlog using logs/ch12.1b, replace
rolling sum=r(sum) se=r(se), window(30): ///
myregress wpi L(1/4).wpi t, lagvar(wpi) nlags(4)
sjlog close, replace

sjlog using logs/ch12.1c, replace
tsset end, quarterly
label variable end Endpoint
generate lo = sum - 1.96 * se
generate hi = sum + 1.96 * se
twoway rarea lo hi end, color(gs12) ylabel(,angle(0)) ///
title("Sum of moving lag coefficients, approx. 95% CI") ///
||  tsline sum, legend(off) scheme(s2mono)
sjlog close, replace

graph display, xsize(5) ysize(4)
graph export fig12_1.eps, replace

sjlog using logs/ch12.2, replace
type _gpctrange.ado
sjlog close, replace

sjlog using logs/ch12.2a, replace
sysuse auto, clear
bysort rep78: egen iqr = pctrange(price) if inrange(rep78, 3, 5)
bysort rep78: egen p8020 = pctrange(price) if inrange(rep78, 3, 5), ///
hi(80) lo(20)
tabstat iqr if inrange(rep78, 3, 5), by(rep78)
tabstat p8020 if inrange(rep78, 3, 5), by(rep78)
sjlog close, replace

!cp pctrange.106.ado pctrange.ado

sjlog using logs/ch12.3,replace
type pctrange.ado
sjlog close, replace

sjlog using logs/ch12.3aa, replace
type testall.do
sjlog close, replace

sjlog using logs/ch12.3a, replace
cd bench/pctrange
do test1
sjlog close, replace
cd ../..

sjlog using logs/ch12.3b, replace
cd bench/pctrange
do test2
sjlog close, replace
cd ../..

sjlog using logs/ch12.3c, replace
cd bench/pctrange
do test3
sjlog close, replace
cd ../..

sjlog using logs/ch12.3d, replace
cd bench/pctrange
do test4
sjlog close, replace
cd ../..

set more off
sjlog using logs/ch12.6, replace
type meanvar.ado
sjlog close, replace

sjlog using logs/ch12.6a, replace
sysuse auto, clear
global subsample foreign
ml model lf meanvar (mu1: price = ) (mu2: price = ) /sigma1 /sigma2
ml maximize, nolog
estimates store unconstr
sjlog close, replace

sjlog using logs/ch12.6b, replace
nlcom ([sigma1]_b[_cons] - [sigma2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons])
nlcom 2*_pi*sqrt(3) * (([mu1]_b[_cons] - [mu2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons]))
sjlog close, replace

sjlog using logs/ch12.6c, replace
constraint 1 [sigma1]_cons = [sigma2]_cons
ml model lf meanvar (mu1: price = ) (mu2: price = ) /sigma1 /sigma2, ///
   constraints(1)
ml maximize, nolog
estimates store constr
nlcom 2*_pi*sqrt(3) * (([mu1]_b[_cons] - [mu2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons]))
sjlog close, replace

sjlog using logs/ch12.6d, replace
lrtest unconstr constr
sjlog close, replace

!cp mynormal_lf.101.ado mynormal_lf.ado
program drop _all
which mynormal_lf

sjlog using logs/ch12.4, replace
type mynormal_lf.ado
sjlog close, replace

!cp mynormal.101.ado mynormal.ado
program drop _all
which mynormal

sjlog using logs/ch12.4a, replace
type mynormal.ado
sjlog close, replace

sjlog using logs/ch12.4b, replace
sysuse auto, clear
mynormal price mpg weight turn
sjlog close, replace

capt program drop mynormal_lf_c1
sjlog using logs/ch12.4ee, replace
type mynormal_lf_c1.ado
sjlog close, replace

prog drop _all
sjlog using logs/ch12.4ff, replace
global x1 mpg 
quietly regress price mpg weight turn
matrix b0 = e(b), ln(e(rmse))
matrix b0[1,1] = ln(-1*b0[1,1])
ml model lf mynormal_lf_c1 (a:) (mu: price = weight turn) /lnsigma, ///
maximize nolog diparm(lnsigma, exp label("sigma")) init(b0,copy)
ml display
sjlog close, replace

sjlog using logs/ch12.4g, replace
nlcom -exp([a]_cons)
sjlog close, replace

sjlog using logs/ch12.6e, replace
type onespell_part1.txt
sjlog close, replace


sjlog using logs/ch12.6f, replace
type onespell_part2.txt
sjlog close, replace

sjlog using logs/ch12.5b, replace
webuse grunfeld, clear
quietly replace invest = . in 28
quietly replace mvalue = . in 55
quietly replace kstock = . in 87
quietly replace kstock = . in 94
onespell invest mvalue kstock, saving(grun1) replace
sjlog close, replace

sjlog using logs/ch12.5c, replace
use grun1, clear
tabulate company
sjlog close, replace

prog drop _all
sjlog using logs/ch6.8a, replace
prog rpost, eclass
syntax, b(string) v(string) cmd(string) es(string) store(string)
ereturn repost b=`b' V=`v', esample(`es')
ereturn local cmdline `cl'
ereturn local cmd `cmd'
estimates store `store'
ereturn display
end
sjlog close, replace

sjlog using logs/ch6.8b, replace 
webuse grunfeld, clear
xtreg invest mvalue kstock, fe
sjlog close, replace

sjlog using logs/ch6.8c, replace
by company: center invest mvalue kstock year
quietly xtdes
local en = r(N)
regress c_invest c_mvalue c_kstock
local nk = r(df_r)
scalar adj = e(df_r) / (e(df_r) - `en' + 1)
matrix b = e(b)
matrix vadj = adj * e(V)
generate byte es = e(sample)
rpost, b(b) v(vadj) cmd(regress) es(es) store(one)
sjlog close, replace

sjlog using logs/ch6.8d, replace
regress c_invest c_mvalue c_year
local nk = r(df_r)
scalar adj = e(df_r) / (e(df_r) - `en' + 1)
matrix b = e(b)
matrix vadj = adj * e(V)
generate byte es = e(sample)
rpost, b(b) v(vadj) cmd(regress) es(es) store(two)
sjlog close, replace

sjlog using logs/ch6.8e, replace
suest one two
test [one_mean]c_mvalue = [two_mean]c_mvalue
sjlog close, replace

