
sjlog using logs/ch7.00, replace
use bpress, clear
bysort sex agegrp: summarize bp
sjlog close, replace

sjlog using logs/ch7.04, replace
statsby mean=r(mean) sd=r(sd) n=r(N), by(agegrp sex) saving(bpstats, replace): summarize bp
use bpstats, clear
list, sepby(agegrp)
sjlog close, replace

sjlog using logs/ch7.05, replace
use ibm, clear
rolling _b _se, window(90) saving(capm, replace) nodots: qreg ibm spx
sjlog close, replace

sjlog using logs/ch7.06, replace
use capm, clear
label variable _b_spx "quantile reg IBM beta"
label variable end "date"
list in 1/5
sjlog close, replace

sjlog using logs/ch7.07, replace
tsset end
format end %tdMonYY
tsline _b_spx, yline(1) ylabel(,angle(0)) saving(fig7_1, replace) scheme(s2mono)
sjlog close, replace

graph display, xsize(4) ysize(3)
graph export fig7_1.eps, replace

sjlog using logs/ch7.08, replace
type simpctile.ado
sjlog close, replace

sjlog using logs/ch7.09, replace
clear
set seed 2007062926
simulate p25=r(p25) p50=r(p50) p75=r(p75), reps(1000) nodots ///
saving(pctiles, replace): simpctile
sjlog close, replace

sjlog using logs/ch7.10, replace
use pctiles, clear
summarize
label variable p50 "Sample median"
histogram p50, normal ylabel(,angle(0)) saving(fig7_2, replace) scheme(s2mono)
sjlog close, replace

graph display, xsize(4) ysize(3)
graph export fig7_2.eps, replace

sjlog using logs/ch7.11, replace
summarize p50, detail
sjlog close, replace

sjlog using logs/ch7.12, replace
use pctiles, clear
qnorm p50, ylabel(,angle(0)) saving(fig7_3, replace) scheme(s2mono)
sjlog close, replace
graph display, xsize(4) ysize(3)
graph export fig7_3.eps, replace

sjlog using logs/ch7.13, replace
use bpress, clear
set seed 2007062926
ttest bp, by(sex)
bootstrap diff=(r(mu_1) - r(mu_2)), nodots: ttest bp, by(sex)
sjlog close, replace

sjlog using logs/appB.9, replace
use gdp4cty, clear
forvalues i = 1/4 {
     generate double lngdp`i' = log(gdp`i')
     summarize lngdp`i'
}
sjlog close, replace

sjlog using logs/appB.10, replace
forvalues y = 1995(2)1999 {
     forvalues i = 2(2)4 {
          summarize gdp`i'_`y'
     }
}
sjlog close, replace

sjlog using logs/appB.11, replace
sysuse lifeexp, clear
local mylist lexp gnppc safewater
foreach v of varlist `mylist' {
     summarize `v'
     correlate popgrowth `v'
     scatter popgrowth `v'
}
sjlog close, replace

sjlog using logs/appB.12, replace
use gdp4cty, clear
local ctycode 111 112 136 134
local i 0
foreach c of local ctycode {
     local ++i
     local rc "`rc' (`i'=`c')"
}
display "`rc'"
recode cc `rc', gen(newcc)
tabulate newcc
sjlog close, replace

sjlog using logs/appB.13, replace
use gdp4cty, clear
local country US UK DE FR
local yrlist 1995 1999
forvalues i = 1/4 {
     local cname: word `i' of `country'
     foreach y of local yrlist {
          rename gdp`i'_`y' gdp`cname'_`y'
     }
}
summarize gdpUS*
sjlog close, replace

sjlog using logs/appB.13a, replace
use gdp4cty, clear
describe gdp*_*
local country US UK DE FR
local yrlist 1995 1999
local ncty: word count `country'
tokenize `country'
forvalues i = 1/`ncty' {
     foreach y of local yrlist {
          rename gdp`i'_`y' gdp``i''_`y'
     }
}
summarize gdpUS*
sjlog close, replace
